unit Eratos_Unit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids;

type
  TForm1 = class(TForm)
    StringGridEratost: TStringGrid;
    Button1: TButton;
    Button2: TButton;
    StringGridPostup: TStringGrid;
    Button3: TButton;
    Label1: TLabel;
    EditN: TEdit;
    procedure Eratosthenes(Sender: TObject);
    procedure Finish(Sender: TObject);
    procedure PostupDeleni(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Eratosthenes(Sender: TObject);
var i,j,m,n,Max  :LongInt;
    Prvocislo :array [1..500000] of boolean;
begin
  Max:=StrToInt(EditN.Text);
  for i:=1 to Max do Prvocislo[i]:=True;
  for i:=2 to Max do
  begin
    j:=2;
    While i*j<=Max do
    begin
      Prvocislo[i*j]:=False;
      inc(j);
    end;
  end;
  m:=-1;n:=0;
  For i:=2 to Max do
    if Prvocislo[i] then
     begin
        inc(m);
        if m>99 then begin m:=0;inc(n);end;
        StringGridEratost.Cells[n,m]:=IntToStr(i);
     end;
end;

procedure TForm1.Finish(Sender: TObject);
begin
  Application.Terminate;
end;


procedure TForm1.PostupDeleni(Sender: TObject);
var i,m,n,TestovaneCislo,Max:DWord;

  Function Prvocislo(Cislo:DWord):Boolean;
  var i:DWord;
  begin
    i:=1;
    Repeat
      inc(i);
    Until (Cislo mod i = 0) or (i>Trunc(sqrt(Cislo)));
    if (Cislo mod i = 0)
     then Prvocislo:=False
     else Prvocislo:=True;
  end;

begin
  Max:=StrToInt(EditN.Text);
  m:=0;n:=0;i:=2;
  StringGridPostup.Cells[m,n]:=IntToStr(i);
  for i:=3 to Max do
    if Prvocislo(i) then
    begin
     begin
        inc(m);
        if m>99 then begin m:=0;inc(n);end;
        StringGridPostup.Cells[n,m]:=IntToStr(i);
     end;
    end;
end;

end.
